// Copyright 2022 Sony Group Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//
// *WARNING*
// THIS FILE IS AUTO-GENERATED BY CODE GENERATOR.
// PLEASE DO NOT EDIT THIS FILE BY HAND!
// If you want to modify this file, edit following files.
// - dl_nccl.h.tmpl
// - dl_nccl_generate.py

#ifndef DL_NCCL_H_
#define DL_NCCL_H_


#ifdef DL_NCCL_MAIN
#define DL_NCCL_API
#else
#define DL_NCCL_API extern
#endif


#include <cuda_runtime.h>
#include <cuda_fp16.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Opaque handle to communicator */
typedef struct ncclComm* ncclComm_t;

#define NCCL_UNIQUE_ID_BYTES 128
typedef struct { char internal[NCCL_UNIQUE_ID_BYTES]; } ncclUniqueId;

typedef enum { ncclSuccess                 =  0,
               ncclUnhandledCudaError      =  1,
               ncclSystemError             =  2,
               ncclInternalError           =  3,
               ncclInvalidArgument         =  4,
               ncclInvalidUsage            =  5,
               ncclNumResults              =  6 } ncclResult_t;


typedef enum { ncclSum        = 0,
               ncclProd       = 1,
               ncclMax        = 2,
               ncclMin        = 3,
               ncclNumOps     = 4 } ncclRedOp_t;

typedef enum { ncclInt8       = 0, ncclChar       = 0,
               ncclUint8      = 1,
               ncclInt32      = 2, ncclInt        = 2,
               ncclUint32     = 3,
               ncclInt64      = 4,
               ncclUint64     = 5,
               ncclFloat16    = 6, ncclHalf       = 6,
               ncclFloat32    = 7, ncclFloat      = 7,
               ncclFloat64    = 8, ncclDouble     = 8,
               ncclNumTypes   = 9 } ncclDataType_t;

// dynamic load libnccl.so, and get required functions by symbol table.
int dl_nccl_init(void);
int dl_nccl_fini(void);

DL_NCCL_API ncclResult_t (*ncclGetUniqueId)(ncclUniqueId* uniqueId);
DL_NCCL_API ncclResult_t (*ncclCommInitRank)(ncclComm_t* comm, int nranks, ncclUniqueId commId, int rank);
DL_NCCL_API ncclResult_t (*ncclCommInitAll)(ncclComm_t* comm, int ndev, const int* devlist);
DL_NCCL_API ncclResult_t (*ncclCommDestroy)(ncclComm_t comm);
DL_NCCL_API ncclResult_t (*ncclReduce)(const void* sendbuff, void* recvbuff, size_t count, ncclDataType_t datatype,ncclRedOp_t op, int root, ncclComm_t comm, cudaStream_t stream);
DL_NCCL_API ncclResult_t (*ncclBcast)(void* buff, size_t count, ncclDataType_t datatype, int root,ncclComm_t comm, cudaStream_t stream);
DL_NCCL_API ncclResult_t (*ncclAllReduce)(const void* sendbuff, void* recvbuff, size_t count,ncclDataType_t datatype, ncclRedOp_t op, ncclComm_t comm, cudaStream_t stream);
DL_NCCL_API ncclResult_t (*ncclReduceScatter)(const void* sendbuff, void* recvbuff,size_t recvcount, ncclDataType_t datatype, ncclRedOp_t op, ncclComm_t comm,cudaStream_t stream);
DL_NCCL_API ncclResult_t (*ncclAllGather)(const void* sendbuff, void* recvbuff, size_t sendcount,ncclDataType_t datatype, ncclComm_t comm, cudaStream_t stream);
DL_NCCL_API ncclResult_t (*ncclGroupStart)( );
DL_NCCL_API ncclResult_t (*ncclGroupEnd)( );
DL_NCCL_API const char* (*ncclGetErrorString)(ncclResult_t result);

#ifdef __cplusplus
} // end extern "C"
#endif

#endif
